module Slowly  where

import Control.Concurrent.STM
import Control.Concurrent
import qualified System.Time as Tm
import GHC.Conc

atm = atomically 

forceSleep = unsafeIOToSTM . threadDelay

main = do 
  v <- atm $ newTVar 1
  forkIO $ do { threadDelay (10^6); atm $ writeTVar v 2; threadDelay (10^6); atm $ writeTVar v 1 }
  (a, b, c) <- atm $ do { a <- readTVar v; forceSleep ((3*10^6) `div` 2); b <- readTVar v; forceSleep ((3*10^6) `div` 2); c <- readTVar v; return (a, b, c) }
  print (a, b, c)
